"use strict";

const HashMap = require("dw/util/HashMap");
const Resource = require("dw/web/Resource");

function PaymentDetailRequest(order, shopLogin, gestPayApikey) {
	var utils = require("*/cartridge/scripts/utils/utils");

	var shopLogin = shopLogin;
	var shopTransactionID = order.orderNo;

	this.body = {};
	this.body.shopLogin = shopLogin;
	this.body.shoptransactionID = shopTransactionID;

	this.headers = new HashMap();
	this.headers["Authorization"] = "apikey " + gestPayApikey;
	this.headers["Content-Type"] = "application/json";

	this.url = utils.getRestUrlByName("gestpay.rest.paymentDetails.post");

	this.getUrl = function () {
		return this.url;
	}

	this.getBodyStringify = function getBody() {
		return JSON.stringify(this.body);
	};

	this.getBody = function getBody() {
		this.body;
	};

	this.getHeaders = function getHeader() {
		return this.headers;
	};

	this.getHeadersStringify = function getHeadersStringify() {
		return this.headers.toString();
	};
}

module.exports = PaymentDetailRequest;